PTLib Version 2.12.9

- Main Page
- Related Pages
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros Pages
Public Member Functions | Protected Attributes | Static Protected Attributes | List of all members
PVideoChannel Class Reference

A class representing a video channel. More...

`#include <video.h>`

Inheritance diagram for PVideoChannel:
[legend]
Collaboration diagram for PVideoChannel:
[legend]

## Public Member Functions
virtual PINDEX | GetGrabWidth ()
| Return the width of the currently selected grabbing device. More...
virtual PINDEX | GetGrabHeight ()
| Return the height of the currently selected grabbing device. More...
virtual PBoolean | Read (void *buf, PINDEX len)
| Low level read from the channel. More...
PBoolean | Write (const void *buf, PINDEX len)
| Low level write to the channel, which is data to be rendered to the local video display device. More...
virtual PBoolean | Write (const void *buf, PINDEX len, void *mark)
| Low level write to the video channel with marker. More...
virtual PBoolean | Redraw (const void *frame)
| Cause the referenced data to be drawn to the previously defined media. More...
PINDEX | GetRenderWidth ()
| Return the previously specified width. More...
PINDEX | GetRenderHeight ()
| Return the previously specified height. More...
virtual void | SetRenderFrameSize (int width, int height)
| Specify the width and height of the video stream, which is to be rendered onto the previously specified device. More...
virtual void | SetRenderFrameSize (int width, int height, int sarwidth, int sarheight)
| Specify the width and height of the video stream, which is to be rendered onto the previously specified device including sample aspect ratio. More...
virtual void | SetGrabberFrameSize (int width, int height)
| Specifiy the width and height of the video stream, which is to be extracted from the previously specified device. More...
virtual void | AttachVideoPlayer (PVideoOutputDevice *device, PBoolean keepCurrent=true)
| Attach a user specific class for rendering video. More...
virtual void | AttachVideoReader (PVideoInputDevice *device, PBoolean keepCurrent=true)
| Attach a user specific class for acquiring video. More...
virtual PVideoInputDevice * | GetVideoReader ()
| Return a pointer to the class for acquiring video. More...
virtual PVideoOutputDevice * | GetVideoPlayer ()
| Return a pointer to the class for displaying video. More...
virtual PBoolean | IsGrabberOpen ()
| See if the grabber is open. More...
virtual PBoolean | IsRenderOpen ()
| See if the rendering device is open. More...
virtual PBoolean | DisableDecode ()
| Allow the outputdevice decide whether the decoder should ignore decode hence not render any output. More...
PBoolean | DisplayRawData (void *videoBuffer)
| Get data from the attached inputDevice, and display on the attached ouptutDevice. More...
virtual void | CloseVideoReader ()
| Destroy the attached grabber class. More...
virtual void | CloseVideoPlayer ()
| Destroy the attached video display class. More...
void | RestrictAccess ()
| Restrict others from using this video channel. More...
void | EnableAccess ()
| Allow free access to this video channel. More...
PBoolean | ToggleVFlipInput ()
| Toggle the vertical flip state of the video grabber. More...
virtual bool | FlowControl (const void *flowData)
| Flow Control information Pass data to the channel for flowControl determination. More...
virtual PBoolean | Close ()
| Close the channel, shutting down the link to the data source. More...
virtual PString | GetName () const
| Get the platform and I/O channel type name of the channel. More...
PString | GetErrorText () const
Public Member Functions inherited from PChannel
PBoolean | SetErrorValues (Errors errorCode, int osError, ErrorGroup group=LastGeneralError)
| Set error values to those specified. More...
virtual Comparison | Compare (const PObject &obj) const
| Get the relative rank of the two strings. More...
virtual PINDEX | HashFunction () const
| Calculate a hash value for use in sets and dictionaries. More...
P_INT_PTR | GetHandle () const
| Get the integer operating system handle for the channel. More...
virtual PChannel * | GetBaseReadChannel () const
| Get the base channel of channel indirection using PIndirectChannel. More...
virtual PChannel * | GetBaseWriteChannel () const
| Get the base channel of channel indirection using PIndirectChannel. More...
void | SetReadTimeout (const PTimeInterval &time)
| Set the timeout for read operations. More...
PTimeInterval | GetReadTimeout () const
| Get the timeout for read operations. More...
virtual PINDEX | GetLastReadCount () const
| Get the number of bytes read by the last Read() call. More...
virtual int | ReadChar ()
| Read a single 8 bit byte from the channel. More...
PBoolean | ReadBlock (void *buf, PINDEX len)
| Read len bytes into the buffer from the channel. More...
PString | ReadString (PINDEX len)
| Read `len` character into a string from the channel. More...
void | SetWriteTimeout (const PTimeInterval &time)
| Set the timeout for write operations to complete. More...
PTimeInterval | GetWriteTimeout () const
| Get the timeout for write operations to complete. More...
virtual PBoolean | Write (const void *buf, PINDEX len, const void *)
| Low level write to the channel with marker. More...
virtual PINDEX | GetLastWriteCount () const
| Get the number of bytes written by the last Write() call. More...
PBoolean | WriteChar (int c)
| Write a single character to the channel. More...
PBoolean | WriteString (const PString &str)
| Write a string to the channel. More...
| ~PChannel ()
| Close down the channel. More...
Errors | GetErrorCode (ErrorGroup group=NumErrorGroups) const
| Get normalised error code. More...
int | GetErrorNumber (ErrorGroup group=NumErrorGroups) const
| Get OS errro code. More...
virtual PString | GetErrorText (ErrorGroup group=NumErrorGroups) const
| Get error message description. More...
virtual bool | ReadAsync (AsyncContext &context)
| Begin an asynchronous read from channel. More...
virtual void | OnReadComplete (AsyncContext &context)
| User callback function for when a `ReadAsync()` call has completed or timed out. More...
virtual bool | WriteAsync (AsyncContext &context)
| Begin an asynchronous write from channel. More...
virtual void | OnWriteComplete (AsyncContext &context)
| User callback function for when a WriteAsync() call has completed or timed out. More...
virtual PBoolean | Shutdown (ShutdownValue option)
| Close one or both of the data streams associated with a channel. More...
virtual bool | SetLocalEcho (bool localEcho)
| Set local echo mode. More...
PBoolean | SetBufferSize (PINDEX newSize)
| Set the iostream buffer size for reads and writes. More...
PBoolean | SendCommandString (const PString &command)
| Send a command meta-string. More...
void | AbortCommandString ()
| Abort a command string that is in progress. More...
Public Member Functions inherited from PObject
unsigned | GetTraceContextIdentifier () const
| Get PTRACE context identifier. More...
void | SetTraceContextIdentifier (unsigned id)
void | GetTraceContextIdentifier (PObject &obj)
void | GetTraceContextIdentifier (PObject *obj)
void | SetTraceContextIdentifier (const PObject &obj)
void | SetTraceContextIdentifier (const PObject *obj)
virtual | ~PObject ()
virtual PObject * | Clone () const
| Create a copy of the class on the heap. More...
template<class CLS >
CLS * | CloneAs () const
| As for Clone() but converts to specified type. More...
virtual const char * | GetClass (unsigned ancestor=0) const
| Get the current dynamic type of the object instance. More...
PBoolean | IsClass (const char *cls) const
virtual PBoolean | InternalIsDescendant (const char *clsName) const
| Determine if the dynamic type of the current instance is a descendent of the specified class. More...
__inline const PObject * | PTraceObjectInstance () const
virtual Comparison | CompareObjectMemoryDirect (const PObject &obj) const
| Determine the byte wise comparison of two objects. More...
bool | operator== (const PObject &obj) const
| Compare the two objects. More...
bool | operator!= (const PObject &obj) const
| Compare the two objects. More...
bool | operator< (const PObject &obj) const
| Compare the two objects. More...
bool | operator> (const PObject &obj) const
| Compare the two objects. More...
bool | operator<= (const PObject &obj) const
| Compare the two objects. More...
bool | operator>= (const PObject &obj) const
| Compare the two objects. More...
virtual void | PrintOn (ostream &strm) const
| Output the contents of the object to the stream. More...
virtual void | ReadFrom (istream &strm)
| Input the contents of the object from the stream. More...

## Protected Attributes
Directions | direction
PString | deviceName
PVideoInputDevice * | mpInput
| Specified video device name, eg /dev/video0. More...
PVideoOutputDevice * | mpOutput
| For grabbing video from the camera. More...
PMutex | accessMutex
| For displaying video on the screen. More...
Protected Attributes inherited from PChannel
P_INT_PTR | os_handle
| The operating system file handle return by standard open() function. More...
Errors | lastErrorCode [NumErrorGroups+1]
| The platform independant error code. More...
int | lastErrorNumber [NumErrorGroups+1]
| The operating system error number (eg as returned by errno). More...
PINDEX | lastReadCount
| Number of byte last read by the Read() function. More...
PINDEX | lastWriteCount
| Number of byte last written by the Write() function. More...
PTimeInterval | readTimeout
| Timeout for read operations. More...
PTimeInterval | writeTimeout
| Timeout for write operations. More...
PString | channelName
| Name of channel. More...
PMutex | px_threadMutex
PXBlockType | px_lastBlockType
PThread * | px_readThread
PThread * | px_writeThread
PMutex | px_writeMutex
PThread * | px_selectThread [3]
PMutex | px_selectMutex [3]
Protected Attributes inherited from PObject
unsigned | m_traceContextIdentifier

## Static Protected Attributes
static PMutex | dictMutex

## Construction
enum | Directions { Recorder, Player }
| PVideoChannel ()
| Create a video channel. More...
| PVideoChannel (const PString &device, Directions dir)
| Create a video channel. More...
| ~PVideoChannel ()

## Open functions
PBoolean | Open (const PString &device, Directions dir)
| Open the specified device for playing or recording. More...
PBoolean | IsOpen () const
| return True if one (or both) of the video device class pointers is non NULL. More...
static PStringArray | GetDeviceNames (Directions dir)
| Get all of the names for video devices/drivers that are available on this platform. More...
static PString | GetDefaultDevice (Directions dir)
| Get the name for the default video devices/driver that is on this platform. More...

## Additional Inherited Members
Public Types inherited from PChannel
enum | PXBlockType { PXReadBlock, PXWriteBlock, PXAcceptBlock, PXConnectBlock }
enum | Errors { NoError, NotFound, FileExists, DiskFull, AccessDenied, DeviceInUse, BadParameter, NoMemory, NotOpen, Timeout, Interrupted, BufferTooSmall, Miscellaneous, ProtocolFailure, Unavailable, NumNormalisedErrors }
| Normalised error codes. More...
enum | ErrorGroup { LastReadError, LastWriteError, LastGeneralError, NumErrorGroups }
| Error groups. More...
typedef PNotifierTemplate < PChannel::AsyncContext & > | AsyncNotifier
enum | ShutdownValue { ShutdownRead = 0, ShutdownWrite = 1, ShutdownReadAndWrite = 2 }
Static Public Member Functions inherited from PChannel
static PString | GetErrorText (Errors lastError, int osError=0)
| Get error message description. More...
static PBoolean | ConvertOSError (P_INT_PTR libcReturnValue, Errors &lastError, int &osError)
| Convert an operating system error into platform independent error. More...
Static Public Member Functions inherited from PObject
static const char * | Class ()
| Get the name of the class as a C string. More...
static __inline const PObject * | PTraceObjectInstance (const char *)
static __inline const PObject * | PTraceObjectInstance (const PObject *obj)
static Comparison | InternalCompareObjectMemoryDirect (const PObject *obj1, const PObject *obj2, PINDEX size)
| Internal function caled from CompareObjectMemoryDirect() More...
Protected Member Functions inherited from PChannel
| PChannel (const PChannel &)
PChannel & | operator= (const PChannel &)
virtual PBoolean | ConvertOSError (P_INT_PTR libcReturnValue, ErrorGroup group=LastGeneralError)
| Convert an operating system error into platform independent error. More...
int | ReadCharWithTimeout (PTimeInterval &timeout)
| Read a character with specified timeout. More...
PBoolean | ReceiveCommandString (int nextChar, const PString &reply, PINDEX &pos, PINDEX start)
PBoolean | PXSetIOBlock (PXBlockType type, const PTimeInterval &timeout)
P_INT_PTR | GetOSHandleAsInt () const
int | PXClose ()
| PChannel ()
| Create the channel. More...
Friends inherited from PObject

## Detailed Description

A class representing a video channel.

This class is provided mainly for the playback or recording of video on the system.

Note that this video channel is implicitly a series of frames in YUV411P format. No conversion is performed on data to/from the channel.

## Member Enumeration Documentation

enum PVideoChannel::Directions

Enumerator
Recorder |
Player |

## Constructor & Destructor Documentation

PVideoChannel::PVideoChannel | ( |  | ) |

Create a video channel.

PVideoChannel::PVideoChannel | ( | const PString & | device,
|  | Directions | dir
| ) |  |

Create a video channel.

Create a reference to the video drivers for the platform.

Parameters

  device | Name of video driver/device
  dir | Video I/O direction

PVideoChannel::~PVideoChannel | ( |  | ) |

## Member Function Documentation

virtual void PVideoChannel::AttachVideoPlayer | ( | PVideoOutputDevice * | device,
|  | PBoolean | keepCurrent = `true`
| ) |  |
| virtual

Attach a user specific class for rendering video.

If keepCurrent is true, an abort is caused when the program attempts to attach a new player when there is already a video player attached.

If keepCurrent is false, the existing video player is deleted before attaching the new player.

virtual void PVideoChannel::AttachVideoReader | ( | PVideoInputDevice * | device,
|  | PBoolean | keepCurrent = `true`
| ) |  |
| virtual

Attach a user specific class for acquiring video.

If keepCurrent is true, an abort is caused when the program attempts to attach a new reader when there is already a video reader attached.

If keepCurrent is false, the existing video reader is deleted before attaching the new reader.

virtual PBoolean PVideoChannel::Close | ( |  | ) |
| virtual

Close the channel, shutting down the link to the data source.

Returns
  true if the channel successfully closed.

Reimplemented from PChannel.

virtual void PVideoChannel::CloseVideoPlayer | ( |  | ) |
| virtual

Destroy the attached video display class.

virtual void PVideoChannel::CloseVideoReader | ( |  | ) |
| virtual

Destroy the attached grabber class.

virtual PBoolean PVideoChannel::DisableDecode | ( |  | ) |
| virtual

Allow the outputdevice decide whether the decoder should ignore decode hence not render any output.

This does not mean the video channel is closed just to not decode and render any frames.

PBoolean PVideoChannel::DisplayRawData | ( | void * | videoBuffer | ) |

Get data from the attached inputDevice, and display on the attached ouptutDevice.

void PVideoChannel::EnableAccess | ( |  | ) |

Allow free access to this video channel.

virtual bool PVideoChannel::FlowControl | ( | const void * | flowData | ) |
| virtual

Flow Control information Pass data to the channel for flowControl determination.

Reimplemented from PChannel.

static PString PVideoChannel::GetDefaultDevice | ( | Directions | dir | ) |
| static

Get the name for the default video devices/driver that is on this platform.

Note that a named device may not necessarily do both playing and recording so the arrays returned with the `dir` parameter in each value is not necessarily the same.

Returns
  A platform dependent string for the video player/recorder.

static PStringArray PVideoChannel::GetDeviceNames | ( | Directions | dir | ) |
| static

Get all of the names for video devices/drivers that are available on this platform.

Note that a named device may not necessarily do both playing and recording so the arrays returned with the `dir` parameter in each value is not necessarily the same.

Returns
  An array of platform dependent strings for each video player/recorder.

Parameters

  dir | Video I/O direction

PString PVideoChannel::GetErrorText | ( |  | ) | const

virtual PINDEX PVideoChannel::GetGrabHeight | ( |  | ) |
| virtual

Return the height of the currently selected grabbing device.

virtual PINDEX PVideoChannel::GetGrabWidth | ( |  | ) |
| virtual

Return the width of the currently selected grabbing device.

virtual PString PVideoChannel::GetName | ( |  | ) | const
| virtual

Get the platform and I/O channel type name of the channel.

For example, it would return the filename in `PFile` type channels.

Returns
  the name of the channel.

Reimplemented from PChannel.

PINDEX PVideoChannel::GetRenderHeight | ( |  | ) |

Return the previously specified height.

PINDEX PVideoChannel::GetRenderWidth | ( |  | ) |

Return the previously specified width.

virtual PVideoOutputDevice* PVideoChannel::GetVideoPlayer | ( |  | ) |
| virtual

Return a pointer to the class for displaying video.

virtual PVideoInputDevice* PVideoChannel::GetVideoReader | ( |  | ) |
| virtual

Return a pointer to the class for acquiring video.

virtual PBoolean PVideoChannel::IsGrabberOpen | ( |  | ) |
| virtual

See if the grabber is open.

PBoolean PVideoChannel::IsOpen | ( |  | ) | const
| virtual

return True if one (or both) of the video device class pointers is non NULL.

If either pointer is non NULL, then a device is ready to be written to, which indicates this channel is open.

Reimplemented from PChannel.

virtual PBoolean PVideoChannel::IsRenderOpen | ( |  | ) |
| virtual

See if the rendering device is open.

PBoolean PVideoChannel::Open | ( | const PString & | device,
|  | Directions | dir
| ) |  |

Open the specified device for playing or recording.

The device name is platform specific and is as returned in the GetDevices() function.

Returns
  true if the video device is valid for playing/recording.

Parameters

  device | Name of video driver/device
  dir | Video I/O direction

virtual PBoolean PVideoChannel::Read | ( | void * | buf,
|  | PINDEX | len
| ) |  |
| virtual

Low level read from the channel.

This function may block until the requested number of characters were read or the read timeout was reached. The GetLastReadCount() function returns the actual number of bytes read.

The GetErrorCode() function should be consulted after Read() returns false to determine what caused the failure.

Returns
  true indicates that at least one character was read from the channel. false means no bytes were read due to timeout or some other I/O error.

Reimplemented from PChannel.

virtual PBoolean PVideoChannel::Redraw | ( | const void * | frame | ) |
| virtual

Cause the referenced data to be drawn to the previously defined media.

void PVideoChannel::RestrictAccess | ( |  | ) |

Restrict others from using this video channel.

virtual void PVideoChannel::SetGrabberFrameSize | ( | int | width,
|  | int | height
| ) |  |
| virtual

Specifiy the width and height of the video stream, which is to be extracted from the previously specified device.

virtual void PVideoChannel::SetRenderFrameSize | ( | int | width,
|  | int | height
| ) |  |
| virtual

Specify the width and height of the video stream, which is to be rendered onto the previously specified device.

virtual void PVideoChannel::SetRenderFrameSize | ( | int | width,
|  | int | height,
|  | int | sarwidth,
|  | int | sarheight
| ) |  |
| virtual

Specify the width and height of the video stream, which is to be rendered onto the previously specified device including sample aspect ratio.

PBoolean PVideoChannel::ToggleVFlipInput | ( |  | ) |

Toggle the vertical flip state of the video grabber.

PBoolean PVideoChannel::Write | ( | const void * | buf,
|  | PINDEX | len
| ) |  |
| virtual

Low level write to the channel, which is data to be rendered to the local video display device.

Reimplemented from PChannel.

virtual PBoolean PVideoChannel::Write | ( | const void * | buf,
|  | PINDEX | len,
|  | void * | mark
| ) |  |
| virtual

Low level write to the video channel with marker.

Parameters

  buf | Pointer to a block of memory to write.
  len | Number of bytes to write.
  mark | Unique Marker to identify write

## Member Data Documentation

PMutex PVideoChannel::accessMutex
| protected

For displaying video on the screen.

PString PVideoChannel::deviceName
| protected

PMutex PVideoChannel::dictMutex
| static protected

Directions PVideoChannel::direction
| protected

PVideoInputDevice* PVideoChannel::mpInput
| protected

Specified video device name, eg /dev/video0.

PVideoOutputDevice* PVideoChannel::mpOutput
| protected

For grabbing video from the camera.

The documentation for this class was generated from the following files:

- video.h